local moduleName = 'Tooltips'
local idTweaks = LibStub('AceAddon-3.0'):GetAddon('idTweaks')
local module = idTweaks:newModule(moduleName, 'AceConsole-3.0', 'AceHook-3.0')

module.defaults = {
  profile = {
    enabled = true,

    anchor = {
      value = 'ANCHOR_CURSOR'
    }
  }
}

module.options = {
  name = moduleName,
  type = 'group',
  args = {
    enabled = {
      order = 1,
      name = 'Enabled',
      desc = 'Enables / Disables the Module',
      get = function()
        return module.db.profile.enabled
      end,
      set = function(_, value)
        module.db.profile.enabled = value
        module:check()
      end,
    },

    anchor = {
      name = 'Anchor',
      type = 'select',
      values = {
        ['ANCHOR_NONE'] = 'Default',
        ['ANCHOR_CURSOR'] = 'Cursor',
        ['ANCHOR_TOPLEFT'] = 'Top Left',
        ['ANCHOR_TOPRIGHT'] = 'Top Right',
        ['ANCHOR_BOTTOMLEFT'] = 'Bottom Left',
        ['ANCHOR_BOTTOMRIGHT'] = 'Bottom Right',
      },
      disabled = function()
        return not module.db.profile.enabled
      end,
      get = function()
        return module.db.profile.anchor.value
      end,
      set = function(_, value)
        module.db.profile.anchor.value = value
      end,
    }
  }
}

function module:enable()
  module:SecureHook('GameTooltip_SetDefaultAnchor')
end

function module:disable()
  module:Unhook('GameTooltip_SetDefaultAnchor')
end

function module:GameTooltip_SetDefaultAnchor(tooltip, selfObject)
  tooltip:SetOwner(selfObject, module.db.profile.anchor.value)
end
